// ============================================================================
// ==                                                                        ==
// == Amdis - Adaptive multidimensional simulations                          ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  TU Dresden                                                            ==
// ==                                                                        ==
// ==  Institut für Wissenschaftliches Rechnen                               ==
// ==  Zellescher Weg 12-14                                                  ==
// ==  01069 Dresden                                                         ==
// ==  germany                                                               ==
// ==                                                                        ==
// ============================================================================
// ==                                                                        ==
// ==  https://gforge.zih.tu-dresden.de/projects/amdis/                      ==
// ==                                                                        ==
// ============================================================================

/** \file ArhWriter.h */

#ifndef AMDIS_ARH_WRITER_H
#define AMDIS_ARH_WRITER_H

#include <iostream>
#include <fstream>

#include "AMDiS_fwd.h"

namespace AMDiS {

  class ArhWriter
  {
  public:
    static void write(std::string filename, Mesh *mesh);

    static void write(std::string filename, Mesh *mesh, DOFVector<double>* vec);

    static void write(std::string filename, Mesh *mesh, 
		      std::vector<DOFVector<double>*> vecs);

  protected:
    static void writeMacroElement(std::ofstream &file, 
				  MeshStructure &code, 
				  std::vector<std::vector<double> >& values,
				  int32_t elIndex);
  };
}

#endif
